import com.google.api.services.youtube.model.SearchResult;

class VideoSuggestion {
    private String name;
    private String link;

    VideoSuggestion(SearchResult searchResult) {
        this.name = searchResult.getSnippet().getTitle();
        this.link = "https://www.youtube.com/watch?" + searchResult.getId().getVideoId();
    }

    @Override
    public String toString() {
        return "[\"" + name + "\", " + link + "]";
    }
}
